/* clock.c -- Send signals to DX programs on clock changes
   Copyright (C) 2000 Dave Turner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.  */

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <time.h>
#include <ctype.h>

#define BASE_SEC_UNIT_MESSAGE   10240
#define BASE_MIN_UNIT_MESSAGE   10250
#define BASE_HOUR_UNIT_MESSAGE  10260

#define BASE_SEC_TENS_MESSAGE   10270
#define BASE_MIN_TENS_MESSAGE   10276
#define BASE_HOUR_TENS_MESSAGE  10282

int last_su, last_mu, last_hu, last_st, last_mt, last_ht;
HWND dxwin;

void sendm (int message) {
	SendMessageA (dxwin, 0x270F, message, 0);
	//printf ("Sending signal %i\n", message);
}

void send_update () {

int sec, min, hour;
int su, mu, hu, st, mt, ht;

time_t now_tt;
struct tm *now;

time (&now_tt);
now = localtime (&now_tt);

sec = now->tm_sec;
su = sec % 10;
st = sec / 10;

min = now->tm_min;
mu = min % 10;
mt = min / 10;

hour = now->tm_hour;
hu = hour % 10;
ht = hour / 10;

if (su != last_su) {
	sendm (BASE_SEC_UNIT_MESSAGE + su);
	last_su = su;
}
if (mu != last_mu) {
	sendm (BASE_MIN_UNIT_MESSAGE + mu);
	last_mu = mu;
}
if (hu != last_hu) {
	sendm (BASE_HOUR_UNIT_MESSAGE + hu);
	last_hu = hu;
}
if (st != last_st) {
	sendm (BASE_SEC_TENS_MESSAGE + st);
	last_st = st;
}
if (mt != last_mt) {
	sendm (BASE_MIN_TENS_MESSAGE + mt);
	last_mt = mt;
}
if (ht != last_ht) {
	sendm (BASE_HOUR_TENS_MESSAGE + ht);
	last_ht = ht;
}

}


int
main (int argc, char *argv[])
{

dxwin = FindWindowA ("DXMain", 0);

while (1) {
send_update ();
sleep (1);
}

exit (0);
}
